SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

Interval subclass: #MeasureInterval
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureInterval class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/3/2012 04:37'!
newFrom: aMeasure to: aMeasure2 
	
	^ self newFrom: aMeasure to: aMeasure2 by: (Measure withAmount: 1 andWithUnit: ( aMeasure unit)).! !

!MeasureInterval class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/3/2012 04:38'!
newFrom: startMeasure to: stopMeasure by: step 

	^ self from: startMeasure to: stopMeasure by: step.! !

!MeasureInterval methodsFor: 'accessing' stamp: 'PaneroGomez 6/3/2012 04:36'!
by
	^ self increment.! !

!MeasureInterval methodsFor: 'accessing' stamp: 'PaneroGomez 6/3/2012 04:36'!
do: aBlock

	| aValue index size |
	index := 0.
	size := self size.
	[index < size]
		whileTrue: [aValue := (self first) + ((self increment) * index).
			index := index + 1.
			aBlock value: aValue]! !

!MeasureInterval methodsFor: 'accessing' stamp: 'PaneroGomez 6/3/2012 04:36'!
from
	
	^ self first.! !

!MeasureInterval methodsFor: 'accessing' stamp: 'PaneroGomez 6/3/2012 11:31'!
size
	
	step < (Measure withAmount:  0 andWithUnit: (step unit))
		ifTrue: [start < stop
				ifTrue: [^ 0]
				ifFalse: [^ (self last - self first) toMeasureFamilyBaseUnit // step toMeasureFamilyBaseUnit + 1]]
		ifFalse: [stop < start
				ifTrue: [^ 0]
				ifFalse: [^ (self last - self first) toMeasureFamilyBaseUnit // step toMeasureFamilyBaseUnit + 1]]! !

!MeasureInterval methodsFor: 'accessing' stamp: 'PaneroGomez 6/3/2012 04:36'!
to
	^ self last .! !

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'PaneroGomez 5/31/2012 21:24'!
canNotConvertMeasurementException
	
	^ UncompatibleMeasurementTypes.! !

!MeasureTest methodsFor: 'temperature units' stamp: 'ExequielGomez 6/2/2012 02:31'!
celsius
	
	^ SimpleMeasureUnit newCelsiusUnit.! !

!MeasureTest methodsFor: 'distance units' stamp: 'ExequielGomez 6/2/2012 02:31'!
centimeter
	
	^ SimpleMeasureUnit newCentimeterUnit.! !

!MeasureTest methodsFor: 'time units' stamp: 'ExequielGomez 6/2/2012 02:31'!
day
	
	^ SimpleMeasureUnit newDayUnit.! !

!MeasureTest methodsFor: 'distance units' stamp: 'ExequielGomez 6/2/2012 02:31'!
decameter
	
	^ SimpleMeasureUnit newDecameterUnit .! !

!MeasureTest methodsFor: 'distance units' stamp: 'ExequielGomez 6/2/2012 02:31'!
decimeter
	
	^ SimpleMeasureUnit newDecimeterUnit.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceExamples 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceUnits 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'ExequielGomez 6/2/2012 13:34'!
eightCubicMeters

	^ Measure newCubicMeter: 8.! !

!MeasureTest methodsFor: 'temperature units' stamp: 'ExequielGomez 6/2/2012 02:31'!
fahrenheit
	
	^ SimpleMeasureUnit newFahrenheitsUnit.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'PaneroGomez 6/3/2012 10:22'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod

	^ initialSpeed + (anAcceleration * aTimePeriod).! !

!MeasureTest methodsFor: 'compound measures' stamp: 'ExequielGomez 6/2/2012 13:33'!
fourSquaredMeters

	^Measure newSquareMeter: 4.! !

!MeasureTest methodsFor: 'distance units' stamp: 'ExequielGomez 6/2/2012 02:31'!
hectometer
	
	^ SimpleMeasureUnit newHectometerUnit .! !

!MeasureTest methodsFor: 'time units' stamp: 'ExequielGomez 6/2/2012 02:31'!
hour
	
	^ SimpleMeasureUnit newHourUnit .! !

!MeasureTest methodsFor: 'temperature units' stamp: 'ExequielGomez 6/2/2012 02:31'!
kelvin
	
	^ SimpleMeasureUnit newKelvinUnit .! !

!MeasureTest methodsFor: 'distance units' stamp: 'ExequielGomez 6/2/2012 02:31'!
kilometer
	
	^ SimpleMeasureUnit newKilometerUnit .! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'ExequielGomez 6/2/2012 02:31'!
meter

	^ SimpleMeasureUnit newMeterUnit .! !

!MeasureTest methodsFor: 'distance units' stamp: 'ExequielGomez 6/2/2012 02:31'!
millimeter
	
	^ SimpleMeasureUnit newMillimeterUnit .! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GomezPanero 5/30/2012 19:21'!
minusOneMeter 
	
	^ Measure newMeter: -1.! !

!MeasureTest methodsFor: 'time units' stamp: 'ExequielGomez 6/2/2012 02:31'!
minute
	
	^ SimpleMeasureUnit newMinuteUnit  .! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'GomezPanero 5/30/2012 19:29'!
oneCelsius
	
	^ Measure newCelsius: 1.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GomezPanero 5/30/2012 19:21'!
oneCentimeter
	
	^ Measure newCentimeter: 1.! !

!MeasureTest methodsFor: 'time measures' stamp: 'ExequielGomez 5/31/2012 00:48'!
oneDay
	
	^ Measure newDay: 1.! !

!MeasureTest methodsFor: 'time measures' stamp: 'ExequielGomez 5/31/2012 00:37'!
oneHour
	
	^ Measure newHour: 1.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GomezPanero 5/30/2012 19:21'!
oneHundredCentimeters
	
	^ Measure newCentimeter: 100.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'PaneroGomez 6/6/2012 01:03'!
oneHundredTwentyOneMetersPerSecond
	
	|numeratorUnitsList denominatorUnitsList|
	
	numeratorUnitsList := OrderedCollection new: 1.
	numeratorUnitsList add: SimpleMeasureUnit newMeterUnit.
	
	denominatorUnitsList := OrderedCollection new: 1.
	denominatorUnitsList add: SimpleMeasureUnit newSecondUnit.

	^ Measure 
		withAmount: 121 
		andWithUnit: 
			(CompoundMeasureUnit withNumeratorUnitsList: numeratorUnitsList andWithDenominatorUnitsList: denominatorUnitsList ).! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GomezPanero 5/30/2012 19:21'!
oneMeter
	
	^ Measure newMeter: 1.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'PaneroGomez 6/6/2012 00:51'!
oneMeterPerSecond

	|numeratorList denominatorList|
	
	numeratorList := OrderedCollection new: 1.
	numeratorList add: SimpleMeasureUnit newMeterUnit.
	
	denominatorList := OrderedCollection new: 1.
	denominatorList add: SimpleMeasureUnit newSecondUnit.

	^ Measure 
		withAmount: 1
		 andWithUnit: (CompoundMeasureUnit withNumeratorUnitsList: numeratorList andWithDenominatorUnitsList: denominatorList ).! !

!MeasureTest methodsFor: 'time measures' stamp: 'GomezPanero 5/30/2012 20:05'!
oneMinute
	
	^Measure newMinute: 1.
! !

!MeasureTest methodsFor: 'time measures' stamp: 'GomezPanero 5/30/2012 19:26'!
oneSecond

	^Measure newSecond: 1.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'ExequielGomez 6/2/2012 13:13'!
oneSquaredMeter

	^ Measure newSquareMeter: 1.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'ExequielGomez 6/2/2012 16:39'!
oneSquaredSecond

	^ Measure newSquareSecond: 1.! !

!MeasureTest methodsFor: 'time units' stamp: 'ExequielGomez 6/2/2012 02:31'!
second
	
	^ SimpleMeasureUnit newSecondUnit  .! !

!MeasureTest methodsFor: 'time measures' stamp: 'ExequielGomez 5/31/2012 00:48'!
sixtyMinutes
	
	^ Measure newMinute: 60.! !

!MeasureTest methodsFor: 'time measures' stamp: 'ExeNico 6/1/2012 18:40'!
sixtyOneSeconds

	^ Measure newSecond: 61.
! !

!MeasureTest methodsFor: 'time measures' stamp: 'PaneroGomez 6/6/2012 00:52'!
sixtySeconds
	
	^Measure newSecond: 60.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:05'!
test01ObjectsRepresentingSameMeasureShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:06'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:08'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'ExequielGomez 5/31/2012 00:04'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'ExequielGomez 5/31/2012 00:16'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celsius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:19'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'ExeNico 6/1/2012 18:36'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:41'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'PaneroGomez 6/6/2012 02:28'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'PaneroGomez 6/5/2012 20:47'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'PaneroGomez 6/3/2012 18:58'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self twoMeters / self oneSecond) = self twoMetersBySecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'efo 5/2/2011 20:56'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'PaneroGomez 6/3/2012 20:46'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'PaneroGomez 6/3/2012 11:22'!
thirtyTwoFahrenheits
	
	^Measure newFahrenheits:  32! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'ExequielGomez 5/31/2012 01:00'!
twentyFourHours
	
	^ Measure newHour: 24.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'PaneroGomez 5/31/2012 21:38'!
twoCelsius
	
	^ Measure newCelsius: 2.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GomezPanero 5/30/2012 19:21'!
twoHundredCentimeters
	
	^ Measure newCentimeter: 200.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GomezPanero 5/30/2012 19:21'!
twoMeters
	
	^ Measure newMeter: 2.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'PaneroGomez 6/6/2012 00:23'!
twoMetersBySecond

	|numeratorList denominatorList|
	
	numeratorList := OrderedCollection new: 1.
	numeratorList add: SimpleMeasureUnit newMeterUnit.
	
	denominatorList := OrderedCollection new: 1.
	denominatorList add: SimpleMeasureUnit newSecondUnit.

	^ Measure 
		withAmount: 2
		 andWithUnit: (CompoundMeasureUnit withNumeratorUnitsList: numeratorList andWithDenominatorUnitsList: denominatorList ).! !

!MeasureTest methodsFor: 'compound measures' stamp: 'PaneroGomez 6/6/2012 00:52'!
twoMetersPerSquaredSecond
	
	|numeratorList denominatorList|
	
	numeratorList := OrderedCollection new: 1.
	numeratorList add: SimpleMeasureUnit newMeterUnit.
	
	denominatorList := OrderedCollection new: 1.
	denominatorList add: SimpleMeasureUnit newSquareSecondUnit.

	^ Measure 
		withAmount: 2
		 andWithUnit: (CompoundMeasureUnit withNumeratorUnitsList: numeratorList andWithDenominatorUnitsList: denominatorList ).! !

!MeasureTest methodsFor: 'compound measures' stamp: 'PaneroGomez 6/5/2012 21:28'!
twoMetersTimesSecond

	|numeratorUnitsList denominatorUnitsList|
	
	numeratorUnitsList := OrderedCollection new: 2.
	numeratorUnitsList add: SimpleMeasureUnit newMeterUnit.
	numeratorUnitsList add: SimpleMeasureUnit newSecondUnit.
	
	denominatorUnitsList := OrderedCollection new: 1.
	denominatorUnitsList add: NoMeasureUnit new.

	^ Measure 
		withAmount: 2 
		andWithUnit: 
			(CompoundMeasureUnit withNumeratorUnitsList: numeratorUnitsList andWithDenominatorUnitsList: denominatorUnitsList ).! !

!MeasureTest methodsFor: 'time measures' stamp: 'PaneroGomez 5/31/2012 21:38'!
twoSeconds
	
	^ Measure newSecond: 2.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'GomezPanero 5/30/2012 20:04'!
zeroCelsius
	
		^Measure newCelsius:  0.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'PaneroGomez 6/3/2012 10:54'!
zeroKelvin
	
	^Measure newKelvin:  0.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'GomezPanero 5/30/2012 19:21'!
zeroMeters

	^ Measure newMeter: 0.! !

!MeasureTest methodsFor: 'time measures' stamp: 'ExeNico 6/1/2012 19:23'!
zeroSeconds
	
	^ Measure newSecond: 0.! !

Magnitude subclass: #Measure
	instanceVariableNames: 'amount unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!Measure class methodsFor: 'temperature' stamp: 'ExequielGomez 6/2/2012 02:31'!
newCelsius: anAmount
 
	^ self new initializeWithAnAmountOf: anAmount andAMeasureUnit: SimpleMeasureUnit newCelsiusUnit! !

!Measure class methodsFor: 'distance' stamp: 'ExequielGomez 6/2/2012 02:31'!
newCentimeter: anAmount
	
	^ self new initializeWithAnAmountOf: anAmount andAMeasureUnit: (SimpleMeasureUnit newCentimeterUnit).! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'ExequielGomez 6/2/2012 13:35'!
newCubicMeter: anAmount

		^ self new initializeWithAnAmountOf: anAmount andAMeasureUnit: (SimpleMeasureUnit newCubicMeterUnit).! !

!Measure class methodsFor: 'time' stamp: 'ExequielGomez 6/2/2012 02:31'!
newDay: anAmount 

	 ^ self new initializeWithAnAmountOf: anAmount andAMeasureUnit: (SimpleMeasureUnit newDayUnit).! !

!Measure class methodsFor: 'distance' stamp: 'ExequielGomez 6/2/2012 02:31'!
newDecameter: anAmount
	
	^ self new initializeWithAnAmountOf: anAmount andAMeasureUnit: SimpleMeasureUnit newDecameterUnit! !

!Measure class methodsFor: 'distance' stamp: 'ExequielGomez 6/2/2012 02:31'!
newDecimeter: anAmount
	
	^ self new initializeWithAnAmountOf: anAmount andAMeasureUnit: (SimpleMeasureUnit newDecimeterUnit).! !

!Measure class methodsFor: 'temperature' stamp: 'ExequielGomez 6/2/2012 02:31'!
newFahrenheits: anAmount 
	
	^ self new initializeWithAnAmountOf: anAmount andAMeasureUnit: SimpleMeasureUnit newFahrenheitsUnit! !

!Measure class methodsFor: 'distance' stamp: 'ExequielGomez 6/2/2012 02:31'!
newHectometer: anAmount
	
	^ self new initializeWithAnAmountOf: anAmount andAMeasureUnit: (SimpleMeasureUnit newHectometerUnit).! !

!Measure class methodsFor: 'time' stamp: 'ExequielGomez 6/2/2012 02:31'!
newHour: anAmount
 
	 ^ self new initializeWithAnAmountOf: anAmount andAMeasureUnit: (SimpleMeasureUnit newHourUnit).! !

!Measure class methodsFor: 'temperature' stamp: 'PaneroGomez 6/3/2012 10:55'!
newKelvin: anAmount 

	^ self new initializeWithAnAmountOf: anAmount andAMeasureUnit: SimpleMeasureUnit newKelvinUnit.! !

!Measure class methodsFor: 'distance' stamp: 'ExequielGomez 6/2/2012 02:31'!
newKilometer: anAmount
	
	^ self new initializeWithAnAmountOf: anAmount andAMeasureUnit: (SimpleMeasureUnit newKilometerUnit).! !

!Measure class methodsFor: 'distance' stamp: 'ExequielGomez 6/2/2012 02:31'!
newMeter: anAmount
	
	^ self new initializeWithAnAmountOf: anAmount andAMeasureUnit: (SimpleMeasureUnit newMeterUnit ).! !

!Measure class methodsFor: 'distance' stamp: 'ExequielGomez 6/2/2012 02:31'!
newMillimeter: anAmount
	
	^ self new initializeWithAnAmountOf: anAmount andAMeasureUnit: (SimpleMeasureUnit newMillimeterUnit).! !

!Measure class methodsFor: 'time' stamp: 'ExequielGomez 6/2/2012 02:31'!
newMinute: anAmount
 
	 ^ self new initializeWithAnAmountOf: anAmount andAMeasureUnit: (SimpleMeasureUnit newMinuteUnit).! !

!Measure class methodsFor: 'time' stamp: 'ExequielGomez 6/2/2012 02:31'!
newSecond: anAmount 

	^ self new initializeWithAnAmountOf: anAmount andAMeasureUnit: (SimpleMeasureUnit newSecondUnit ).! !

!Measure class methodsFor: 'distance' stamp: 'ExequielGomez 6/2/2012 13:13'!
newSquareMeter: anAmount
	
	^ self new initializeWithAnAmountOf: anAmount andAMeasureUnit: (SimpleMeasureUnit newSquareMeterUnit).! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'ExequielGomez 6/2/2012 16:40'!
newSquareSecond: anAmount 
 
	^ (self new) initializeWithAnAmountOf: anAmount andAMeasureUnit: (SimpleMeasureUnit newSquareSecondUnit).! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/31/2012 20:26'!
withAmount: anAmount andWithUnit: aMeasureUnit 
	
	^ self new initializeWithAnAmountOf: anAmount andAMeasureUnit: aMeasureUnit.! !

!Measure methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/6/2012 02:41'!
* multiplier 

	|amountInresultUnit unitResult amountIBaseUnit|
	
	(multiplier isNumber) 
		ifTrue: [
			^ Measure withAmount: (amount * multiplier) andWithUnit: unit.
		] ifFalse:[
			"multiplico las unidades"
			unitResult := self unit * multiplier unit. 
			
			"si me quedo sin unidad, entonces realizo la multiplicacin directamente"
			(unitResult isKindOf: NoMeasureUnit ) ifTrue: [
				^ amount * multiplier amount.
			].
			
			"calculo la cantidad en la unidad base respectiva a cada medida"
			amountIBaseUnit := (self toMeasureFamilyBaseUnit) * (multiplier toMeasureFamilyBaseUnit).
			
			"calculo la cantidad respecto de la unidad resultante"
			amountInresultUnit := unitResult baseUnitToFamilyBaseUnit: amountIBaseUnit..
			
			^ Measure withAmount: amountInresultUnit andWithUnit: unitResult.
		] .! !

!Measure methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/6/2012 03:01'!
+ aMeasure
	
	|amountInBaseUnit amountResult|
	
	self unit signalIfAreInDiferentFamilies: aMeasure unit.
	
	(self unit = aMeasure unit) ifTrue: [
		^ Measure withAmount: (self amount + aMeasure amount) andWithUnit: self unit.
	].
	
	amountInBaseUnit := self toMeasureFamilyBaseUnit + aMeasure toMeasureFamilyBaseUnit. 
	amountResult :=  unit baseUnitToFamilyBaseUnit: amountInBaseUnit.
	^ Measure withAmount: (amountResult) andWithUnit: unit.! !

!Measure methodsFor: 'arithmetic' stamp: 'PaneroGomez 5/31/2012 20:12'!
- aMeasure 
	
	^ self + aMeasure negated .! !

!Measure methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/4/2012 00:46'!
/ divisor

	^ self * ( divisor reciprocal ).! !

!Measure methodsFor: 'comparing' stamp: 'ExeNico 6/1/2012 19:10'!
< aMeasure 
	
	self unit signalIfAreInDiferentFamilies: aMeasure unit .
	
	^self toMeasureFamilyBaseUnit  < aMeasure toMeasureFamilyBaseUnit.! !

!Measure methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:22'!
=  otherMeasure

	(otherMeasure isKindOf: self class) ifFalse: [^false].
	
	^ 		( 	
				(self unit measureFamily isTheSameFamilyAs: otherMeasure unit measureFamily) and:
				[ self toMeasureFamilyBaseUnit = otherMeasure toMeasureFamilyBaseUnit ]
			) 
		or:
			( 	
				(self unit measureFamily isTheSameFamilyAs: otherMeasure unit measureFamily) not and:
				[ (self amount = 0 & otherMeasure amount = 0 & ((self unit unitName = 'celsius') not) & ((otherMeasure unit unitName = 'celsius') not)) ]
			).! !

!Measure methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/4/2012 00:31'!
\\ aMeasure 
	
	| amountInBaseUnit |
	amountInBaseUnit := self toMeasureFamilyBaseUnit \\ aMeasure toMeasureFamilyBaseUnit.
		
	^ Measure withAmount: (self unit transformFunctionToTheBAseUnit inverse: amountInBaseUnit) andWithUnit: unit .! !

!Measure methodsFor: 'accesing' stamp: 'GomezPanero 5/21/2012 20:40'!
amount

	^ amount! !

!Measure methodsFor: 'converting' stamp: 'PaneroGomez 6/6/2012 01:17'!
convertTo: aMeasureUnit 
	
	|amountInTheRquestedUnit i|
	
	self unit signalIfAreInDiferentFamilies: aMeasureUnit .
	
	amountInTheRquestedUnit := amount .
	i := self unit factor.
	[ i > 0 ] whileTrue:[
		amountInTheRquestedUnit := ((self unit) blockForTransformToTheUnit: aMeasureUnit) value: amountInTheRquestedUnit .
		i := i-1.
	].
	
	^ Measure withAmount: amountInTheRquestedUnit andWithUnit: aMeasureUnit.
	

	
! !

!Measure methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:05'!
hash 

	^ self toMeasureFamilyBaseUnit hash + self unit measureFamily hash.! !

!Measure methodsFor: 'initializing' stamp: 'PaneroGomez 5/31/2012 20:25'!
initializeWithAnAmountOf: anAmount andAMeasureUnit: aMeasureUnit

	amount := anAmount.
	unit := aMeasureUnit.! !

!Measure methodsFor: 'converting' stamp: 'ExeNico 6/1/2012 19:28'!
negated

	^ Measure withAmount: (self amount negated) andWithUnit: self unit .! !

!Measure methodsFor: 'printing' stamp: 'PaneroGomez 5/22/2012 00:45'!
printOn: aStream

	aStream nextPutAll: amount printString, ' ', unit printString.
	(amount > 1) 
		ifTrue: [ aStream nextPutAll: 's'].! !

!Measure methodsFor: 'converting' stamp: 'ExequielGomez 6/2/2012 19:42'!
reciprocal

	^ Measure withAmount: (amount reciprocal) andWithUnit: (self unit reciprocal).! !

!Measure methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/3/2012 04:38'!
to: aMeasure 

	^ MeasureInterval newFrom: self to: aMeasure.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/3/2012 04:39'!
to: aMeasure by: aMeasureStep

	^ MeasureInterval newFrom: self to: aMeasure by: aMeasureStep.! !

!Measure methodsFor: 'converting' stamp: 'ExequielGomez 6/2/2012 12:35'!
toMeasureFamilyBaseUnit

	^ unit amountToFamilyBaseUnit: amount.! !

!Measure methodsFor: 'accesing' stamp: 'GomezPanero 5/21/2012 20:41'!
unit

	^ unit! !

Object subclass: #LinearFunction
	instanceVariableNames: 'a0 a1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!LinearFunction class methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/30/2012 21:21'!
newWithA0: anA0 withA1: anA1


	^ (self new) initializeWithA0: anA0 withA1: anA1.! !

!LinearFunction methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/30/2012 21:51'!
eval: aValue

	^ a0 + (a1 * aValue).

! !

!LinearFunction methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/30/2012 21:21'!
initializeWithA0: anA0 withA1: anA1.

	a0 := anA0.
	a1 := anA1.

! !

!LinearFunction methodsFor: 'as yet unclassified' stamp: 'GomezPanero 5/30/2012 21:03'!
inverse: aValue

	^ (aValue - a0)/a1.

! !

!LinearFunction methodsFor: 'as yet unclassified' stamp: 'ExequielGomez 5/31/2012 00:54'!
printOn: aStream

	^ aStream nextPutAll: '' , (a0 printString) , ' + x*' , (a1  printString )
! !

Object subclass: #MeasureFamily
	instanceVariableNames: 'familyName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

MeasureFamily subclass: #CompoundMeasureFamily
	instanceVariableNames: 'numeratorFamilies denominatorFamilies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!CompoundMeasureFamily class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/5/2012 20:11'!
withNumeratorFamilies: aFamilyCollection andWithDenominatorFamilies: otherFamilyCollection

	^ self new initializeWithNumeratorFamilies: aFamilyCollection andWithDenominatorFamilies: otherFamilyCollection.! !

!CompoundMeasureFamily methodsFor: 'accessing' stamp: 'PaneroGomez 6/6/2012 03:44'!
denominatorFamilies

	^ denominatorFamilies.! !

!CompoundMeasureFamily methodsFor: 'initializing' stamp: 'PaneroGomez 6/5/2012 21:39'!
initializeWithNumeratorFamilies: aFamilyCollection andWithDenominatorFamilies: otherFamilyCollection

	|compoundName addFamilyNamesFromCollectionBlock|
	
	compoundName := ''.
	
	addFamilyNamesFromCollectionBlock := [:collection | collection from: 1 to: collection size do: [:family | compoundName := compoundName, ' ',  family familyName]].
	
	(aFamilyCollection size > 0)
		ifTrue: [ addFamilyNamesFromCollectionBlock value: aFamilyCollection ]
		ifFalse: [ compoundName := '1' ].
	(otherFamilyCollection size > 0)
		ifTrue: [ compoundName := compoundName, ' / '. addFamilyNamesFromCollectionBlock value: otherFamilyCollection ].
		
	familyName := compoundName.
	numeratorFamilies := aFamilyCollection.
	denominatorFamilies := otherFamilyCollection.! !

!CompoundMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:24'!
isTheSameFamilyAs: otherFamily

	^ otherFamily isTheSameFamilyAsTheCompoundFamily: self.! !

!CompoundMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:33'!
isTheSameFamilyAsNoMeasureDamily: otherFamily

	^ false.! !

!CompoundMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:27'!
isTheSameFamilyAsTheCompoundFamily: otherCompoundFamily

	|comparatorBlock iterator result|
	
	result := true.
	
	((numeratorFamilies size = otherCompoundFamily numeratorFamilies  size) not or: [ (denominatorFamilies size = otherCompoundFamily denominatorFamilies  size) not ])
		ifTrue: [ ^ UncompatibleMeasurementTypes signalWithTheUnit: self andTheUnit: otherCompoundFamily ].
	
	comparatorBlock := [ :family :otherFamily | result := result & family isTheSameFamilyAs: otherFamily ].
	
	iterator := numeratorFamilies size.
	[iterator > 0] whileTrue: [
		comparatorBlock value: (numeratorFamilies at: iterator) value: (otherCompoundFamily numeratorFamilies at: iterator).
		iterator := iterator - 1.
	].
	
	iterator := denominatorFamilies size.
	[iterator > 0] whileTrue: [
		comparatorBlock value: (denominatorFamilies at: iterator) value: (otherCompoundFamily denominatorFamilies at: iterator).
		iterator := iterator - 1.
	].

	^ result.! !

!CompoundMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:25'!
isTheSameFamilyAsTheDistanceFamily: otherFamily

	^ false.! !

!CompoundMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:25'!
isTheSameFamilyAsTheTemperatureFamily: otherFamily

	^ false.! !

!CompoundMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:25'!
isTheSameFamilyAsTheTimeFamily: otherFamily

	^ false.! !

!CompoundMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:27'!
mustBeFromTheSameFamilyAs: otherFamily

	^ otherFamily mustBeFromTheSameFamilyAsTheCompoundFamily: self.! !

!CompoundMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:48'!
mustBeFromTheSameFamilyAsTheCompoundFamily: otherCompoundFamily

	|comparatorBlock iterator|
	
	((numeratorFamilies size = otherCompoundFamily numeratorFamilies  size) not or: [ (denominatorFamilies size = otherCompoundFamily denominatorFamilies  size) not ])
		ifTrue: [ ^ UncompatibleMeasurementTypes signalWithTheUnit: self andTheUnit: otherCompoundFamily ].
	
	comparatorBlock := [ :family :otherFamily | family mustBeFromTheSameFamilyAs: otherFamily ].
	
	iterator := numeratorFamilies size.
	[iterator > 0] whileTrue: [
		comparatorBlock value: (numeratorFamilies at: iterator) value: (otherCompoundFamily numeratorFamilies at: iterator).
		iterator := iterator - 1.
	].
	
	iterator := denominatorFamilies size.
	[iterator > 0] whileTrue: [
		comparatorBlock value: (denominatorFamilies at: iterator) value: (otherCompoundFamily denominatorFamilies at: iterator).
		iterator := iterator - 1.
	].! !

!CompoundMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:53'!
mustBeFromTheSameFamilyAsTheDistanceFamily: aDistanceFamily

	^ UncompatibleMeasurementTypes signalWithTheUnit: self andTheUnit: aDistanceFamily! !

!CompoundMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:37'!
mustBeFromTheSameFamilyAsTheNoMeasureFamily: otherFamily

	^ UncompatibleMeasurementTypes signalWithTheUnit: self andTheUnit: otherFamily! !

!CompoundMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:55'!
mustBeFromTheSameFamilyAsTheTemperatureFamily: aTemperatureFamily

	^ UncompatibleMeasurementTypes signalWithTheUnit: self andTheUnit: aTemperatureFamily! !

!CompoundMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:54'!
mustBeFromTheSameFamilyAsTheTimeFamily: aTimeFamily

	^ UncompatibleMeasurementTypes signalWithTheUnit: self andTheUnit: aTimeFamily! !

!CompoundMeasureFamily methodsFor: 'accessing' stamp: 'PaneroGomez 6/6/2012 03:44'!
numeratorFamilies

	^ numeratorFamilies.! !

!CompoundMeasureFamily methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/6/2012 00:13'!
performMultiplicationBetweenACompoundUnit: aCompoundMeasureUnit andAnotherSimpleUnit: aSimpleMeasureUnit

	((denominatorFamilies select: [ :family | family = aSimpleMeasureUnit measureFamily ]) size > 0)
		ifTrue: [ ^ aCompoundMeasureUnit multiplyWithASimpleUnitThatExistsInTheDenominator: aSimpleMeasureUnit ]
		ifFalse: [ ^ aCompoundMeasureUnit multiplyWithASimpleUnitThatNotExistsInTheDenominator: aSimpleMeasureUnit ].! !

!MeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/5/2012 20:07'!
= otherMeasureFamily

	 ^ familyName = otherMeasureFamily familyName.! !

!MeasureFamily methodsFor: 'accessing' stamp: 'PaneroGomez 6/4/2012 23:11'!
familyName

	^ familyName.! !

!MeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:06'!
hash

	 ^ familyName hash.! !

!MeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/4/2012 23:06'!
isTheSameFamilyAs: otherFamily

	self subclassResponsibility.! !

!MeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:13'!
mustBeFromTheSameFamilyAs: otherFamily

	self subclassResponsibility.! !

!MeasureFamily methodsFor: 'printing' stamp: 'PaneroGomez 6/4/2012 23:12'!
printOn: aStream

	^ aStream nextPutAll: (self familyName).! !

MeasureFamily subclass: #NoMeasureFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!NoMeasureFamily methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/5/2012 21:17'!
initialize

	familyName := '1'.! !

!NoMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:28'!
isTheSameFamilyAs: otherFamily

	^ otherFamily isTheSameFamilyAsNoMeasureDamily: self.! !

!NoMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:29'!
isTheSameFamilyAsNoMeasureDamily: otherFamily

	^ true.! !

!NoMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:36'!
isTheSameFamilyAsTheCompoundFamily: otherCompoundFamily

	^ false.! !

!NoMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:27'!
isTheSameFamilyAsTheDistanceFamily: otherCompoundFamily

	^ false.! !

!NoMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:27'!
isTheSameFamilyAsTheTemperatureFamily: otherCompoundFamily

	^ false.! !

!NoMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:28'!
isTheSameFamilyAsTheTimeFamily: otherCompoundFamily

	^ false.! !

!NoMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:35'!
mustBeFromTheSameFamilyAs: otherFamily

	^ otherFamily mustBeFromTheSameFamilyAsTheNoMeasureFamily: self.! !

!NoMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:51'!
mustBeFromTheSameFamilyAsTheCompoundFamily: otherCompoundFamily

	^ UncompatibleMeasurementTypes signalWithTheUnit: self andTheUnit: otherCompoundFamily.! !

!NoMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:55'!
mustBeFromTheSameFamilyAsTheDistanceFamily: otherDistanceFamily

	^ UncompatibleMeasurementTypes signalWithTheUnit: self andTheUnit: otherDistanceFamily.! !

!NoMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:35'!
mustBeFromTheSameFamilyAsTheNoMeasureFamily: otherFamily

	^ true.! !

!NoMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:56'!
mustBeFromTheSameFamilyAsTheTemperatureFamily: otherTemperatureFamily

	^ UncompatibleMeasurementTypes signalWithTheUnit: self andTheUnit: otherTemperatureFamily.! !

!NoMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:56'!
mustBeFromTheSameFamilyAsTheTimeFamily: otherTimeFamily

	^ UncompatibleMeasurementTypes signalWithTheUnit: self andTheUnit: otherTimeFamily.! !

MeasureFamily subclass: #SimpleMeasureFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

SimpleMeasureFamily subclass: #DistanceFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DistanceFamily methodsFor: 'initializing' stamp: 'PaneroGomez 6/4/2012 23:26'!
initialize

	familyName := 'distance'.! !

!DistanceFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:31'!
isTheSameFamilyAs: otherFamily

	^ otherFamily isTheSameFamilyAsTheDistanceFamily: self.! !

!DistanceFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:31'!
isTheSameFamilyAsTheDistanceFamily: otherFamily

	^ true.! !

!DistanceFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:32'!
isTheSameFamilyAsTheTemperatureFamily: otherFamily

	^ false.! !

!DistanceFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:32'!
isTheSameFamilyAsTheTimeFamily: otherFamily

	^ false.! !

!DistanceFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:14'!
mustBeFromTheSameFamilyAs: otherFamily

	^ otherFamily mustBeFromTheSameFamilyAsTheDistanceFamily: self.! !

!DistanceFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:15'!
mustBeFromTheSameFamilyAsTheDistanceFamily: otherFamily

	^ true.! !

!DistanceFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:19'!
mustBeFromTheSameFamilyAsTheTemperatureFamily: otherFamily

	^ UncompatibleMeasurementTypes signalWithTheUnit: self andTheUnit: otherFamily.! !

!DistanceFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:19'!
mustBeFromTheSameFamilyAsTheTimeFamily: otherFamily

	^ UncompatibleMeasurementTypes signalWithTheUnit: self andTheUnit: otherFamily.! !

!DistanceFamily methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 21:56'!
performMultiplicationBetweenASimpleUnit: aSimpleUnit andAnotherDistanceSimpleUnit: otherSimpleUnit 

	^ otherSimpleUnit multiplyWithASimpleUnitFromTheSameFamily: aSimpleUnit.! !

!DistanceFamily methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 21:55'!
performMultiplicationBetweenASimpleUnit: aSimpleMeasureUnit andAnotherSimpleUnit: otherSimpleMeasureUnit 

	^ otherSimpleMeasureUnit measureFamily performMultiplicationBetweenASimpleUnit: otherSimpleMeasureUnit andAnotherDistanceSimpleUnit: aSimpleMeasureUnit.! !

!DistanceFamily methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 21:57'!
performMultiplicationBetweenASimpleUnit: aSimpleUnit andAnotherTemperatureSimpleUnit: otherSimpleUnit 

	^ otherSimpleUnit multiplyWithASimpleUnitFromDifferentFamily: aSimpleUnit.! !

!DistanceFamily methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 21:58'!
performMultiplicationBetweenASimpleUnit: aSimpleUnit andAnotherTimeSimpleUnit: otherSimpleUnit 

	^ otherSimpleUnit multiplyWithASimpleUnitFromDifferentFamily: aSimpleUnit.! !

!SimpleMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:34'!
isTheSameFamilyAsNoMeasureDamily: otherFamily

	^ false.! !

!SimpleMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:27'!
isTheSameFamilyAsTheCompoundFamily: otherCompoundFamily

	^ false.! !

!SimpleMeasureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:51'!
mustBeFromTheSameFamilyAsTheCompoundFamily: otherCompoundFamily

	^ UncompatibleMeasurementTypes signalWithTheUnit: self andTheUnit: otherCompoundFamily.! !

!SimpleMeasureFamily methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/6/2012 00:13'!
performMultiplicationBetweenASimpleUnit: aSimpleMeasureUnit andACompoundUnit: aCompoundMeasureUnit 

	^ aCompoundMeasureUnit measureFamily performMultiplicationBetweenACompoundUnit: aCompoundMeasureUnit andAnotherSimpleUnit: aSimpleMeasureUnit.! !

!SimpleMeasureFamily methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 21:54'!
performMultiplicationBetweenASimpleUnit: aSimpleUnit andAnotherSimpleUnit: otherSimpleUnit 

	self subclassResponsibility.! !

SimpleMeasureFamily subclass: #TemperatureFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TemperatureFamily methodsFor: 'initializing' stamp: 'PaneroGomez 6/4/2012 23:27'!
initialize

	familyName := 'temperature'.! !

!TemperatureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:32'!
isTheSameFamilyAs: otherFamily

	^ otherFamily isTheSameFamilyAsTheTemperatureFamily: self.! !

!TemperatureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:31'!
isTheSameFamilyAsTheDistanceFamily: otherFamily

	^ false.! !

!TemperatureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:32'!
isTheSameFamilyAsTheTemperatureFamily: otherFamily

	^ true.! !

!TemperatureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:32'!
isTheSameFamilyAsTheTimeFamily: otherFamily

	^ false.! !

!TemperatureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:21'!
mustBeFromTheSameFamilyAs: otherFamily

	^ otherFamily mustBeFromTheSameFamilyAsTheTemperatureFamily: self.! !

!TemperatureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:20'!
mustBeFromTheSameFamilyAsTheDistanceFamily: otherFamily

	^ UncompatibleMeasurementTypes signalWithTheUnit: self andTheUnit: otherFamily.! !

!TemperatureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:20'!
mustBeFromTheSameFamilyAsTheTemperatureFamily: otherFamily

	^ true.! !

!TemperatureFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:20'!
mustBeFromTheSameFamilyAsTheTimeFamily: otherFamily

	^ UncompatibleMeasurementTypes signalWithTheUnit: self andTheUnit: otherFamily.! !

!TemperatureFamily methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 22:02'!
performMultiplicationBetweenASimpleUnit: aSimpleUnit andAnotherDistanceSimpleUnit: otherSimpleUnit 

	^ otherSimpleUnit multiplyWithASimpleUnitFromDifferentFamily: aSimpleUnit.! !

!TemperatureFamily methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 22:00'!
performMultiplicationBetweenASimpleUnit: aSimpleUnit andAnotherSimpleUnit: otherSimpleUnit 

	^ otherSimpleUnit measureFamily performMultiplicationBetweenASimpleUnit: otherSimpleUnit andAnotherTemperatureSimpleUnit: aSimpleUnit.! !

!TemperatureFamily methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 22:01'!
performMultiplicationBetweenASimpleUnit: aSimpleUnit andAnotherTemperatureSimpleUnit: otherSimpleUnit 

	^ otherSimpleUnit multiplyWithASimpleUnitFromTheSameFamily: aSimpleUnit.! !

!TemperatureFamily methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 22:01'!
performMultiplicationBetweenASimpleUnit: aSimpleUnit andAnotherTimeSimpleUnit: otherSimpleUnit 

	^ otherSimpleUnit multiplyWithASimpleUnitFromDifferentFamily: aSimpleUnit.! !

SimpleMeasureFamily subclass: #TimeFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!TimeFamily methodsFor: 'initializing' stamp: 'PaneroGomez 6/4/2012 23:27'!
initialize

	familyName := 'time'.! !

!TimeFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:32'!
isTheSameFamilyAs: otherFamily

	^ otherFamily isTheSameFamilyAsTheTimeFamily: self.! !

!TimeFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:31'!
isTheSameFamilyAsTheDistanceFamily: otherFamily

	^ false.! !

!TimeFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:32'!
isTheSameFamilyAsTheTemperatureFamily: otherFamily

	^ false.! !

!TimeFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 04:32'!
isTheSameFamilyAsTheTimeFamily: otherFamily

	^ true.! !

!TimeFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:22'!
mustBeFromTheSameFamilyAs: otherFamily

	^ otherFamily mustBeFromTheSameFamilyAsTheTimeFamily: self.! !

!TimeFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:23'!
mustBeFromTheSameFamilyAsTheDistanceFamily: otherFamily

	^ UncompatibleMeasurementTypes signalWithTheUnit: self andTheUnit: otherFamily.! !

!TimeFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:22'!
mustBeFromTheSameFamilyAsTheTemperatureFamily: otherFamily

	^ UncompatibleMeasurementTypes signalWithTheUnit: self andTheUnit: otherFamily.! !

!TimeFamily methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 03:22'!
mustBeFromTheSameFamilyAsTheTimeFamily: otherFamily

	^ true.! !

!TimeFamily methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 22:04'!
performMultiplicationBetweenASimpleUnit: aSimpleUnit andAnotherDistanceSimpleUnit: otherSimpleUnit 

	^ otherSimpleUnit multiplyWithASimpleUnitFromDifferentFamily: aSimpleUnit.! !

!TimeFamily methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 22:03'!
performMultiplicationBetweenASimpleUnit: aSimpleUnit andAnotherSimpleUnit: otherSimpleUnit 

	^ otherSimpleUnit measureFamily performMultiplicationBetweenASimpleUnit: otherSimpleUnit andAnotherTimeSimpleUnit:  aSimpleUnit.! !

!TimeFamily methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 22:03'!
performMultiplicationBetweenASimpleUnit: aSimpleUnit andAnotherTemperatureSimpleUnit: otherSimpleUnit 

	^ otherSimpleUnit multiplyWithASimpleUnitFromDifferentFamily: aSimpleUnit.! !

!TimeFamily methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 22:05'!
performMultiplicationBetweenASimpleUnit: aSimpleUnit andAnotherTimeSimpleUnit: otherSimpleUnit 

	^ otherSimpleUnit multiplyWithASimpleUnitFromTheSameFamily: aSimpleUnit.! !

Object subclass: #MeasureUnit
	instanceVariableNames: 'measureFamily'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

MeasureUnit subclass: #CompoundMeasureUnit
	instanceVariableNames: 'numeratorUnitsList denominatorUnitsList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!CompoundMeasureUnit class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/6/2012 00:48'!
withNumeratorUnitsList: aUnitsList andWithDenominatorUnitsList: otherUnitsList

	|	numeratorListCopy denominatorListCopy 
		resultNumeratorList 
		resultDenominatorList 
		numeratorUnitsFromTheSameFamilyAsBlock 
		denominatorUnitsFromTheSameFamilyAsBlock 
		unitListIsANoMeasureUnitBlock 	|
	
	numeratorListCopy := aUnitsList copy.
	denominatorListCopy := otherUnitsList copy.
	
	unitListIsANoMeasureUnitBlock := [:collection | ( collection size = 1 and: [(collection at: 1) isKindOf: NoMeasureUnit] )].

	( ( unitListIsANoMeasureUnitBlock value: aUnitsList ) or: [ unitListIsANoMeasureUnitBlock value: otherUnitsList ] ) ifTrue: [
		^ self new initializeWithNumeratorUnitsList: aUnitsList andWithDenominatorUnitsList: otherUnitsList.
	].

	resultNumeratorList := OrderedCollection new.
	resultDenominatorList := OrderedCollection new.
	
	numeratorUnitsFromTheSameFamilyAsBlock := [:unit | aUnitsList select: [:aUnit | (unit measureFamily isTheSameFamilyAs: aUnit measureFamily)]].	
	denominatorUnitsFromTheSameFamilyAsBlock := [:unit | otherUnitsList select: [:otherUnit | (unit measureFamily isTheSameFamilyAs: otherUnit measureFamily)]].
	
	
	numeratorListCopy from: 1 to: numeratorListCopy size do: 
														[:unit | 
															((denominatorUnitsFromTheSameFamilyAsBlock value: unit) size = 0) ifTrue: [
																resultNumeratorList add: unit.
															] ifFalse: [
																(denominatorUnitsFromTheSameFamilyAsBlock value: unit) collect: [:sameFamilyUnit | ((unit factor > sameFamilyUnit factor) ifTrue: [
																	resultNumeratorList add: (SimpleMeasureUnit newFrom: unit andFactor: (unit factor - sameFamilyUnit factor)). 
																	])
																].
															].
														].
	
	denominatorListCopy from: 1 to: denominatorListCopy size do: 
														[:unit | 
															((numeratorUnitsFromTheSameFamilyAsBlock value: unit) size = 0) ifTrue: [
																resultDenominatorList add: unit.
															] ifFalse: [
																(numeratorUnitsFromTheSameFamilyAsBlock value: unit) collect: [:sameFamilyUnit | ((unit factor > sameFamilyUnit factor) ifTrue: [
																	resultDenominatorList add: (SimpleMeasureUnit newFrom: unit andFactor: (unit factor - sameFamilyUnit factor)). 
																	])
																].
															].
														].

	
	^ self new initializeWithNumeratorUnitsList: resultNumeratorList andWithDenominatorUnitsList: resultDenominatorList.
	
	"													
	resultDenominatorList := denominatorListCopy select: [:unit | aUnitsList collect: [:otherUnit | otherUnit measureFamily isTheSameFamilyAs: unit measureFamily] size  = 0].
	
	(resultNumeratorList size = 0 and: [^ resultDenominatorList size = 0]) ifTrue: [^ self new initializeWithNumeratorUnitsList: aUnitsList andWithDenominatorUnitsList: otherUnitsList.].
	"
	! !

!CompoundMeasureUnit methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/6/2012 00:53'!
* otherUnit

	^ otherUnit multiplyWithACompoundUnit: self.! !

!CompoundMeasureUnit methodsFor: 'converting' stamp: 'PaneroGomez 6/5/2012 21:31'!
amountToFamilyBaseUnit: anAmount 

	|amountInFamilyBaseUnit|
	
	amountInFamilyBaseUnit := anAmount.
	
	numeratorUnitsList from: 1 to: numeratorUnitsList size do: [:unit | amountInFamilyBaseUnit := unit amountToFamilyBaseUnit: amountInFamilyBaseUnit ]. 
	denominatorUnitsList from: 1 to: denominatorUnitsList size do: [:unit | amountInFamilyBaseUnit := amountInFamilyBaseUnit / (unit amountToFamilyBaseUnit: 1)].

	^ amountInFamilyBaseUnit.
	! !

!CompoundMeasureUnit methodsFor: 'converting' stamp: 'PaneroGomez 6/5/2012 21:27'!
baseUnitToFamilyBaseUnit: anAmountInBaseUnit 

	|amountInFamilyBaseUnit|
	
	amountInFamilyBaseUnit := anAmountInBaseUnit.
	
	numeratorUnitsList from: 1 to: numeratorUnitsList size do: [:unit | amountInFamilyBaseUnit := unit baseUnitToFamilyBaseUnit: amountInFamilyBaseUnit ]. 
	denominatorUnitsList from: 1 to: denominatorUnitsList size do: [:unit | amountInFamilyBaseUnit := amountInFamilyBaseUnit / (unit baseUnitToFamilyBaseUnit: 1)].

	^ amountInFamilyBaseUnit.! !

!CompoundMeasureUnit methodsFor: 'accessing' stamp: 'PaneroGomez 6/4/2012 23:41'!
denominatorUnitsList 

	^ denominatorUnitsList.! !

!CompoundMeasureUnit methodsFor: 'initializing' stamp: 'PaneroGomez 6/5/2012 20:19'!
initializeWithNumeratorUnitsList: aUnitsList andWithDenominatorUnitsList: otherUnitsList

	|numeratorFamilyList denominatorFamilyList|
	
	numeratorUnitsList := aUnitsList.
	denominatorUnitsList := otherUnitsList.
	
	numeratorFamilyList := numeratorUnitsList collect: [:unit | unit measureFamily].
	denominatorFamilyList := denominatorUnitsList collect: [:unit | unit measureFamily].
	
	measureFamily := CompoundMeasureFamily withNumeratorFamilies: numeratorFamilyList andWithDenominatorFamilies: denominatorFamilyList.
	! !

!CompoundMeasureUnit methodsFor: 'accessing' stamp: 'PaneroGomez 6/5/2012 20:28'!
measureFamily
	
	^ measureFamily.! !

!CompoundMeasureUnit methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/6/2012 02:07'!
multiplyWithACompoundUnit:  aCompoundUnit
	
	|intermediateResult|
	
	intermediateResult := self.
	
	aCompoundUnit numeratorUnitsList from: 1 to: (aCompoundUnit numeratorUnitsList size) do: [ :unit | intermediateResult := intermediateResult * unit ].
	
	intermediateResult := intermediateResult reciprocal.
	
	aCompoundUnit denominatorUnitsList from: 1 to: (aCompoundUnit denominatorUnitsList size) do: [ :unit | intermediateResult := intermediateResult * unit ].
	
	^ intermediateResult reciprocal.! !

!CompoundMeasureUnit methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/6/2012 02:32'!
multiplyWithANoMeasureUnit: otherNoMeasureUnit

	^ self.! !

!CompoundMeasureUnit methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/6/2012 01:06'!
multiplyWithASimpleUnit: aSimpleMeasureUnit 
	
	^ aSimpleMeasureUnit measureFamily performMultiplicationBetweenASimpleUnit: aSimpleMeasureUnit andACompoundUnit: self.! !

!CompoundMeasureUnit methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/6/2012 01:15'!
multiplyWithASimpleUnitThatExistsInTheDenominator: aSimpleUnit

	|numeratorUnitFromTheSameFamily denominatorUnitFromTheSameFamily resultNumeratorList resultDenominatorList numeratorListCopy denominatorListCopy|
	
	numeratorListCopy := numeratorUnitsList copy.
	denominatorListCopy := denominatorUnitsList copy.
	
	denominatorUnitFromTheSameFamily := (denominatorListCopy select: [:unit | unit measureFamily = aSimpleUnit measureFamily ]) at: 1.
	
	(denominatorUnitFromTheSameFamily factor > aSimpleUnit factor)
		ifTrue: [ 
			denominatorListCopy at: (denominatorListCopy indexOf: denominatorUnitFromTheSameFamily) put: (SimpleMeasureUnit newFrom: denominatorUnitFromTheSameFamily andFactor: (denominatorUnitFromTheSameFamily factor - aSimpleUnit factor)).
			resultDenominatorList := denominatorListCopy.
			resultNumeratorList := numeratorListCopy.
		]
		ifFalse: [
			(denominatorUnitFromTheSameFamily factor = aSimpleUnit factor)
				ifTrue: [
					denominatorListCopy removeAt: (denominatorListCopy indexOf: denominatorUnitFromTheSameFamily).
					resultDenominatorList := denominatorListCopy.
					resultNumeratorList := numeratorListCopy.
				]
				ifFalse: [
					(denominatorUnitFromTheSameFamily factor < aSimpleUnit factor)
						ifTrue: [
							denominatorListCopy removeAt: (denominatorListCopy indexOf: denominatorUnitFromTheSameFamily).
							resultDenominatorList := denominatorListCopy.
			
							((numeratorListCopy select: [:unit | unit measureFamily = aSimpleUnit measureFamily ]) size > 0)
								ifTrue: [ 
									numeratorUnitFromTheSameFamily := (numeratorListCopy select: [:unit | unit measureFamily = aSimpleUnit measureFamily ]) at: 1.
									numeratorListCopy at: (numeratorListCopy indexOf: numeratorUnitFromTheSameFamily) put: (SimpleMeasureUnit newFrom: numeratorUnitFromTheSameFamily andFactor: (numeratorUnitFromTheSameFamily factor + (aSimpleUnit factor - denominatorUnitFromTheSameFamily factor))).
									resultNumeratorList := numeratorListCopy.
								]
								ifFalse: [ resultNumeratorList := numeratorListCopy add: aSimpleUnit ].
						].
				].
		].
	
	( resultDenominatorList size = 0 and: [ resultNumeratorList size = 1 ] )
		ifTrue: [ ^ resultNumeratorList at: 1 ]
		ifFalse: [ ^ CompoundMeasureUnit withNumeratorUnitsList: resultNumeratorList  andWithDenominatorUnitsList: resultDenominatorList ].! !

!CompoundMeasureUnit methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/6/2012 02:21'!
multiplyWithASimpleUnitThatNotExistsInTheDenominator: aSimpleUnit

	|numeratorUnitFromTheSameFamily resultNumeratorList resultDenominatorList numeratorListCopy|

	numeratorListCopy := numeratorUnitsList copy.
	resultDenominatorList := denominatorUnitsList.

	((numeratorListCopy select: [:unit | unit measureFamily = aSimpleUnit measureFamily ]) size > 0)
		ifTrue: [ 
			numeratorUnitFromTheSameFamily := (numeratorListCopy select: [:unit | unit measureFamily = aSimpleUnit measureFamily ]) at: 1.
			numeratorListCopy at: (numeratorListCopy indexOf: numeratorUnitFromTheSameFamily) put: (SimpleMeasureUnit newFrom: numeratorUnitFromTheSameFamily andFactor: (numeratorUnitFromTheSameFamily factor + aSimpleUnit factor)).
			resultNumeratorList := numeratorListCopy.
		]
		ifFalse: [ 
			(numeratorListCopy size = 1 and: [ (numeratorListCopy at: 1) isKindOf: NoMeasureUnit ])
				ifTrue: [ 
					numeratorListCopy at: 1 put: aSimpleUnit.
					resultNumeratorList := numeratorListCopy.
				]
				ifFalse: [ resultNumeratorList := numeratorListCopy add: aSimpleUnit ].
		].
		
	^ CompoundMeasureUnit withNumeratorUnitsList: resultNumeratorList andWithDenominatorUnitsList: resultDenominatorList.! !

!CompoundMeasureUnit methodsFor: 'accessing' stamp: 'PaneroGomez 6/4/2012 23:40'!
numeratorUnitsList

	^ numeratorUnitsList.! !

!CompoundMeasureUnit methodsFor: 'printing' stamp: 'PaneroGomez 6/5/2012 19:41'!
printOn: aStream
	
	(numeratorUnitsList size > 0)
		ifTrue: [ numeratorUnitsList asStringOn: aStream delimiter: ' * ' ]
		ifFalse: [ aStream nextPutAll: '1' ].
	(denominatorUnitsList size > 0)
		ifTrue: [ aStream nextPutAll: ' / '. denominatorUnitsList asStringOn: aStream delimiter: ' * ' ].! !

!CompoundMeasureUnit methodsFor: 'converting' stamp: 'PaneroGomez 6/6/2012 02:05'!
reciprocal
	
	^ CompoundMeasureUnit withNumeratorUnitsList: denominatorUnitsList andWithDenominatorUnitsList: numeratorUnitsList.! !

!MeasureUnit methodsFor: 'arithmetic' stamp: 'ExequielGomez 6/2/2012 19:20'!
* otherUnit

	^ self subclassResponsibility.! !

!MeasureUnit methodsFor: 'comparing' stamp: 'PaneroGomez 6/5/2012 09:27'!
= otherUnit

	^ (self measureFamily = otherUnit measureFamily ) & (self printString = otherUnit printString).! !

!MeasureUnit methodsFor: 'converting' stamp: 'PaneroGomez 6/3/2012 20:54'!
adaptToInteger: aNumber andSend: aSelector

	^ Measure withAmount: aNumber andWithUnit: self. ! !

!MeasureUnit methodsFor: 'comparing' stamp: 'PaneroGomez 6/6/2012 01:18'!
amountToFamilyBaseUnit: anAmount 

	self subclassResponsibility.
	! !

!MeasureUnit methodsFor: 'converting' stamp: 'PaneroGomez 6/4/2012 00:18'!
baseUnitToFamilyBaseUnit: anAmountInBaseUnit

	self subclassResponsibility.! !

!MeasureUnit methodsFor: 'comparing' stamp: 'PaneroGomez 6/4/2012 00:13'!
blockForTransformToTheUnit: otherUnit 

	"Mensaje que devuelve un bloque que al evaluarlo con una cantidad en la unidad self, devuelve la cantidad equivalente en la unidad  otherUnit"
	
	^ [ :anAmoun |
		((otherUnit divisorUnit amountToFamilyBaseUnit: 1) / (self divisorUnit amountToFamilyBaseUnit: 1)) * (otherUnit multiplierUnit baseUnitToFamilyBaseUnit: (self amountToFamilyBaseUnit: anAmoun)).
	    ]
	! !

!MeasureUnit methodsFor: 'accessing' stamp: 'PaneroGomez 6/5/2012 19:51'!
measureFamily

	self subclassResponsibility.! !

!MeasureUnit methodsFor: 'printing' stamp: 'PaneroGomez 6/5/2012 19:37'!
printOn: aStream

	self subclassResponsibility.! !

!MeasureUnit methodsFor: 'converting' stamp: 'PaneroGomez 6/5/2012 20:51'!
reciprocal

	self subclassResponsibility.! !

!MeasureUnit methodsFor: 'error' stamp: 'PaneroGomez 6/6/2012 03:18'!
signalIfAreInDiferentFamilies: otherUnit
	
	self measureFamily mustBeFromTheSameFamilyAs: otherUnit measureFamily.! !

MeasureUnit subclass: #NoMeasureUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!NoMeasureUnit methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/6/2012 02:31'!
* otherUnit

	^ otherUnit multiplyWithANoMeasureUnit: self.! !

!NoMeasureUnit methodsFor: 'converting' stamp: 'PaneroGomez 6/5/2012 21:32'!
amountToFamilyBaseUnit: anAmount 

	^ 1.! !

!NoMeasureUnit methodsFor: 'converting' stamp: 'PaneroGomez 6/5/2012 21:25'!
baseUnitToFamilyBaseUnit: anAmountInBaseUnit 

	^ 1.! !

!NoMeasureUnit methodsFor: 'initializing' stamp: 'PaneroGomez 6/5/2012 21:16'!
initialize

	measureFamily := NoMeasureFamily new.! !

!NoMeasureUnit methodsFor: 'accessing' stamp: 'PaneroGomez 6/5/2012 21:16'!
measureFamily

	^ measureFamily.! !

!NoMeasureUnit methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/6/2012 02:32'!
multiplyWithACompoundUnit:  aCompoundUnit

	^ aCompoundUnit.! !

!NoMeasureUnit methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/6/2012 02:33'!
multiplyWithANoMeasureUnit:  aNoMeasureUnit

	^ self.! !

!NoMeasureUnit methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/6/2012 02:32'!
multiplyWithASimpleUnit:  aSimpleUnit

	^ aSimpleUnit.! !

!NoMeasureUnit methodsFor: 'printing' stamp: 'PaneroGomez 6/6/2012 01:19'!
printOn: aStream

	^ aStream nextPutAll: 'no unit'.! !

MeasureUnit subclass: #SimpleMeasureUnit
	instanceVariableNames: 'unitName transformFunction factor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!SimpleMeasureUnit class methodsFor: 'temperature unit' stamp: 'PaneroGomez 6/4/2012 23:28'!
newCelsiusUnit

	^ (SimpleMeasureUnit withName: 'celsius' inTheMeasureFamily: (TemperatureFamily new) withTransformFunctionToTheBaseUnit: ( LinearFunction newWithA0: 0 withA1: 1)).! !

!SimpleMeasureUnit class methodsFor: 'distance unit' stamp: 'PaneroGomez 6/4/2012 23:28'!
newCentimeterUnit 

	^ (SimpleMeasureUnit withName: 'centimeter' inTheMeasureFamily: (DistanceFamily new) withTransformFunctionToTheBaseUnit:  ( LinearFunction newWithA0: 0 withA1: 10) ).! !

!SimpleMeasureUnit class methodsFor: 'distance unit' stamp: 'PaneroGomez 6/4/2012 23:29'!
newCubicMeterUnit

	^ (SimpleMeasureUnit withName: 'meter' inTheMeasureFamily: (DistanceFamily new) withTransformFunctionToTheBaseUnit: ( LinearFunction newWithA0: 0 withA1: 1000) andWithFactor: 3).! !

!SimpleMeasureUnit class methodsFor: 'time units' stamp: 'PaneroGomez 6/4/2012 23:35'!
newDayUnit

	^ (SimpleMeasureUnit withName: 'day' inTheMeasureFamily: (TimeFamily new) withTransformFunctionToTheBaseUnit: ( LinearFunction newWithA0: 0 withA1: (24*60*60000))).! !

!SimpleMeasureUnit class methodsFor: 'distance unit' stamp: 'PaneroGomez 6/4/2012 23:30'!
newDecameterUnit

	^ (SimpleMeasureUnit withName: 'decameter' inTheMeasureFamily: (DistanceFamily new) withTransformFunctionToTheBaseUnit: ( LinearFunction newWithA0: 0 withA1: 10000)).! !

!SimpleMeasureUnit class methodsFor: 'distance unit' stamp: 'PaneroGomez 6/4/2012 23:30'!
newDecimeterUnit 

	^ (SimpleMeasureUnit withName: 'decimeter' inTheMeasureFamily: (DistanceFamily new) withTransformFunctionToTheBaseUnit:( LinearFunction newWithA0: 0 withA1: 100)).! !

!SimpleMeasureUnit class methodsFor: 'temperature unit' stamp: 'PaneroGomez 6/4/2012 23:31'!
newFahrenheitsUnit

	^ (SimpleMeasureUnit withName: 'fahrenheit' inTheMeasureFamily: (TemperatureFamily new) withTransformFunctionToTheBaseUnit: ( LinearFunction newWithA0: (-32*5/9) withA1: (5/9))). ! !

!SimpleMeasureUnit class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/5/2012 12:15'!
newFrom: aSimpleMeasureUnit andFactor: aFactor 
	
	^ self withName: aSimpleMeasureUnit unitName inTheMeasureFamily: aSimpleMeasureUnit measureFamily withTransformFunctionToTheBaseUnit: aSimpleMeasureUnit transformFunctionToTheBAseUnit andWithFactor: aFactor.! !

!SimpleMeasureUnit class methodsFor: 'distance unit' stamp: 'PaneroGomez 6/4/2012 23:31'!
newHectometerUnit

	^ (SimpleMeasureUnit withName: 'hectometer' inTheMeasureFamily: (DistanceFamily new) withTransformFunctionToTheBaseUnit: ( LinearFunction newWithA0: 0 withA1: 100000)).! !

!SimpleMeasureUnit class methodsFor: 'time units' stamp: 'PaneroGomez 6/4/2012 23:32'!
newHourUnit 
	
	^ (SimpleMeasureUnit withName: 'hour' inTheMeasureFamily: (TimeFamily new) withTransformFunctionToTheBaseUnit: ( LinearFunction newWithA0: 0 withA1: (60*60*1000))).! !

!SimpleMeasureUnit class methodsFor: 'temperature unit' stamp: 'PaneroGomez 6/4/2012 23:32'!
newKelvinUnit
	
	^ (SimpleMeasureUnit withName: 'kelvin' inTheMeasureFamily: (TemperatureFamily new) withTransformFunctionToTheBaseUnit: ( LinearFunction newWithA0:(-273.15) withA1: 1)). ! !

!SimpleMeasureUnit class methodsFor: 'distance unit' stamp: 'PaneroGomez 6/4/2012 23:32'!
newKilometerUnit

	^ (SimpleMeasureUnit withName: 'kilometer' inTheMeasureFamily: (DistanceFamily new) withTransformFunctionToTheBaseUnit: ( LinearFunction newWithA0: 0 withA1: 1000000)).! !

!SimpleMeasureUnit class methodsFor: 'distance unit' stamp: 'PaneroGomez 6/4/2012 23:33'!
newMeterUnit

	^ (SimpleMeasureUnit withName: 'meter' inTheMeasureFamily: (DistanceFamily new) withTransformFunctionToTheBaseUnit: ( LinearFunction newWithA0: 0 withA1: 1000)).! !

!SimpleMeasureUnit class methodsFor: 'distance unit' stamp: 'PaneroGomez 6/4/2012 23:33'!
newMillimeterUnit

	^ (SimpleMeasureUnit withName: 'millimeter' inTheMeasureFamily: (DistanceFamily new) withTransformFunctionToTheBaseUnit: ( LinearFunction newWithA0: 0 withA1: 1)).! !

!SimpleMeasureUnit class methodsFor: 'time units' stamp: 'PaneroGomez 6/4/2012 23:33'!
newMinuteUnit
	
	^ (SimpleMeasureUnit withName: 'minute' inTheMeasureFamily: (TimeFamily new) withTransformFunctionToTheBaseUnit: ( LinearFunction newWithA0: 0 withA1: 60000)).! !

!SimpleMeasureUnit class methodsFor: 'time units' stamp: 'PaneroGomez 6/4/2012 23:33'!
newSecondUnit

	^ (SimpleMeasureUnit withName: 'second' inTheMeasureFamily: (TimeFamily new) withTransformFunctionToTheBaseUnit: ( LinearFunction newWithA0: 0 withA1: 1000)).! !

!SimpleMeasureUnit class methodsFor: 'distance unit' stamp: 'PaneroGomez 6/4/2012 23:34'!
newSquareMeterUnit

	^ (SimpleMeasureUnit withName: 'meter' inTheMeasureFamily: (DistanceFamily new) withTransformFunctionToTheBaseUnit: ( LinearFunction newWithA0: 0 withA1: 1000) andWithFactor: 2).! !

!SimpleMeasureUnit class methodsFor: 'time units' stamp: 'PaneroGomez 6/4/2012 23:34'!
newSquareSecondUnit
	
	^ (SimpleMeasureUnit withName: 'second' inTheMeasureFamily: (TimeFamily new) withTransformFunctionToTheBaseUnit: ( LinearFunction newWithA0: 0 withA1: 1000) andWithFactor: 2).! !

!SimpleMeasureUnit class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/4/2012 23:24'!
withName: aUnitName inTheMeasureFamily: aFamily withTransformFunctionToTheBaseUnit: aFunction

	^ self new initializeWithAName: aUnitName inTheMeasureFamily: aFamily andWithTransformFunctionToTheBaseUnit: aFunction andFactor: 1 .! !

!SimpleMeasureUnit class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/4/2012 23:22'!
withName: aUnitName inTheMeasureFamily: aFamily withTransformFunctionToTheBaseUnit: aFunction andWithFactor: aFactor 

	^ self new initializeWithAName: aUnitName inTheMeasureFamily: aFamily andWithTransformFunctionToTheBaseUnit: aFunction andFactor: aFactor. ! !

!SimpleMeasureUnit methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 20:57'!
* otherUnit

	^ otherUnit multiplyWithASimpleUnit: self.! !

!SimpleMeasureUnit methodsFor: 'converting' stamp: 'PaneroGomez 6/3/2012 20:24'!
amountToFamilyBaseUnit: anAmount 

	|i amountInTheRquestedUnit|
	
	amountInTheRquestedUnit := anAmount.
	
	i := self factor.
	[ i > 0 ] whileTrue:[
		amountInTheRquestedUnit := transformFunction eval: amountInTheRquestedUnit..
		i := i-1.
	].

	^ amountInTheRquestedUnit.! !

!SimpleMeasureUnit methodsFor: 'converting' stamp: 'PaneroGomez 6/4/2012 00:17'!
baseUnitToFamilyBaseUnit: anAmountInBaseUnit 

	|amountInTheRquestedUnit i|
	
	amountInTheRquestedUnit := anAmountInBaseUnit .
	
	i := self factor.
	[ i > 0 ] whileTrue:[
		amountInTheRquestedUnit := transformFunction inverse: amountInTheRquestedUnit.
		i := i-1.
	].
	
	^ amountInTheRquestedUnit.! !

!SimpleMeasureUnit methodsFor: 'converting' stamp: 'ExequielGomez 6/2/2012 13:40'!
blockForTransformToTheUnit: otherUnit 

	^ [:anAmount |  
		otherUnit baseUnitToFamilyBaseUnit: (self amountToFamilyBaseUnit: anAmount).
	   ]! !

!SimpleMeasureUnit methodsFor: 'accessing' stamp: 'ExequielGomez 6/2/2012 03:03'!
factor 

	^ factor.! !

!SimpleMeasureUnit methodsFor: 'initializing' stamp: 'PaneroGomez 6/4/2012 23:23'!
initializeWithAName: aUnitName inTheMeasureFamily: aFamily andWithTransformFunctionToTheBaseUnit: aFunction andFactor: aFactor
	
	unitName := aUnitName.
	measureFamily := aFamily.
	transformFunction := aFunction.
	factor := aFactor.! !

!SimpleMeasureUnit methodsFor: 'accessing' stamp: 'PaneroGomez 6/4/2012 23:37'!
measureFamily
	
	^ measureFamily.! !

!SimpleMeasureUnit methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 20:58'!
multiplyWithACompoundUnit: aCompoundMeasureUnit

	^ aCompoundMeasureUnit multiplyWithASimpleUnit: self.! !

!SimpleMeasureUnit methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/6/2012 02:31'!
multiplyWithANoMeasureUnit: otherNoMeasureUnit

	^ self.! !

!SimpleMeasureUnit methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 21:53'!
multiplyWithASimpleUnit:  otherSimpleUnit

	^ otherSimpleUnit measureFamily performMultiplicationBetweenASimpleUnit: otherSimpleUnit andAnotherSimpleUnit: self.! !

!SimpleMeasureUnit methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 21:03'!
multiplyWithASimpleUnitFromDifferentFamily: otherSimpleUnit
	
	|numeratorList denominatorList|
	
	numeratorList := OrderedCollection new:2.
	numeratorList add: self.
	numeratorList add: otherSimpleUnit.
	
	denominatorList := OrderedCollection new:1.
	denominatorList add: NoMeasureUnit new.
	
	^ CompoundMeasureUnit withNumeratorUnitsList: numeratorList andWithDenominatorUnitsList: denominatorList.! !

!SimpleMeasureUnit methodsFor: 'arithmetic' stamp: 'PaneroGomez 6/5/2012 00:17'!
multiplyWithASimpleUnitFromTheSameFamily: otherSimpleUnit

	^ SimpleMeasureUnit newFrom: self andFactor: (self factor + otherSimpleUnit factor).! !

!SimpleMeasureUnit methodsFor: 'printing' stamp: 'ExequielGomez 6/2/2012 13:16'!
printOn: aStream

	(factor > 1) ifTrue: [
		^ aStream nextPutAll: unitName , '^' , (factor printString) .	
		].
	
	^ aStream nextPutAll: unitName.! !

!SimpleMeasureUnit methodsFor: 'converting' stamp: 'PaneroGomez 6/5/2012 21:02'!
reciprocal

	|numeratorUnitList denominatorUnitList|
	
	numeratorUnitList := OrderedCollection new: 1.
	numeratorUnitList add: NoMeasureUnit new.
	
	denominatorUnitList := OrderedCollection new: 1.
	denominatorUnitList add: self.
	
	^ CompoundMeasureUnit withNumeratorUnitsList: numeratorUnitList andWithDenominatorUnitsList: denominatorUnitList.! !

!SimpleMeasureUnit methodsFor: 'accessing' stamp: 'PaneroGomez 6/4/2012 00:31'!
transformFunctionToTheBAseUnit

	^ transformFunction.! !

!SimpleMeasureUnit methodsFor: 'accessing' stamp: 'PaneroGomez 6/3/2012 20:03'!
unitName

	^ unitName.! !

Error subclass: #UncompatibleMeasurementTypes
	instanceVariableNames: 'otherUnit aUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!UncompatibleMeasurementTypes class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/31/2012 21:43'!
signalWithTheUnit: aMeasureUnit andTheUnit: aMeasureUnit2 

	^ (self new initializeWithUnit: aMeasureUnit andWithUnit: aMeasureUnit2) signal.! !

!UncompatibleMeasurementTypes methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/3/2012 23:53'!
description

	^ 'Uncompatible measure types. Measure type: ', aUnit unitName, ' from family: ', aUnit measureFamilyName, ' cannot operate with the measure typ: ', otherUnit unitName, ' from family: ', otherUnit measureFamilyName.! !

!UncompatibleMeasurementTypes methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 5/31/2012 21:45'!
initializeWithUnit: aMeasureUnit andWithUnit: aMeasureUnit2 
	
	aUnit := aMeasureUnit.
	otherUnit := aMeasureUnit2.! !
